#import "MyComplex.h"

@implementation MyComplex

-(id) init
{
	self = [super init];
	if (!self) return nil;
	else
	{
		return self;
	}
}

- (void) SetReal : (double)aReal
{
	if (aReal != 0.0)
	{
		real = aReal;
	}
}

- (void) SetImaginary : (double)anImaginary
{
	if (anImaginary != 0.0)
	{
		imaginary = anImaginary;
	}
}

- (double) GetReal
{
	return real;
}

- (double) GetImaginary
{
	return imaginary;
}

- (MyComplex*) Add : (MyComplex*)otherComplex
{
	if (otherComplex != 0)
	{
		double oReal = [otherComplex GetReal];
		double oImaginary = [otherComplex GetImaginary];
		real += oReal;
		imaginary += oImaginary;
	}
	return self;
}

- (MyComplex*) Multiply: (MyComplex*)otherComplex
{
	if (otherComplex != 0)
	{
		double oReal = [otherComplex GetReal];
		double oImaginary = [otherComplex GetImaginary];
		real = (oReal*real) - (oImaginary*imaginary);
		imaginary = (imaginary*oReal)+(real*oImaginary);		
	}
	return self;
}

- (BOOL) Equals: (id) otherObject
{
	if (real == [otherObject GetReal] && imaginary == [otherObject GetReal])
		return true;
	else
		return false;
}

- (BOOL) GreaterThan: (id) otherObject
{
	if (real >= [otherObject GetReal] && imaginary >= [otherObject GetReal])
		return true;
	else
		return false;
}
@end
