#import "MyComplexDemo.h"
#import <stdio.h>

@implementation MyComplexDemo

- (id) init
{
	self = [super init];
	if (!self)
	{
		NSLog(@"Super Class Initialization : Failed \n");
		return nil;
	}
	else
	{
		dummyA = [[MyComplex alloc] init];
		dummyB = [[MyComplex alloc] init];
		demoWriter = [[Writer alloc] init];	
		demoReader = [[Reader alloc] init];
		NSLog(@"Super Class Initialization : Done \n");
		return self;
	}
}

- (void) WriteWelcome
{
	[[demoWriter class] WriteString: @"Welcome to MyComplex Demo Application \n"];
	[[demoWriter class] WriteString: @"This little app will demonstrate calculating with complex numbers \n"];
}

- (void) SetupDummyComplexes
{
	[self SetupDummy_A];
	[self SetupDummy_B];
}

- (void) SetupDummy_A
{
	double tReal, tImaginary;
	[[demoWriter class] WriteString: @"Please enter complex A's Real:"];
	tReal = [demoReader ReadDouble];
	[[demoWriter class] WriteString: @"Please enter complex A's Imaginary:"];  	
	tImaginary = [demoReader ReadDouble];
	[dummyA SetReal : tReal];
	[dummyA SetImaginary : tImaginary];
}

- (void) SetupDummy_B
{
	double tReal, tImaginary;
	demoReader = [[Reader alloc] init];
	[[demoWriter class] WriteString: @"Please enter complex B's Real:"];
	tReal = [demoReader ReadDouble];
	[[demoWriter class] WriteString: @"Please enter complex B's Imaginary:"];  	
	tImaginary = [demoReader ReadDouble];
	[dummyB SetReal : tReal];
	[dummyB SetImaginary : tImaginary];
}

- (double) GetReal_A
{
	return [dummyA GetReal];
}

- (double) GetReal_B
{
	return [dummyB GetReal];
}

- (double) GetImaginary_A
{ 
	return [dummyA GetImaginary]; 
}

- (double) GetImaginary_B
{
	return [dummyB GetImaginary];
}

- (void) DemoOperationAdd
{
	[dummyA Add: dummyB];
}

- (void) DemoOperationMultiply
{		
	[dummyA Multiply: dummyB];
}
@end
