/* All Rights reserved */

#include <AppKit/AppKit.h>
#include "CalculatorManager.h"

@implementation CalculatorManager

- (BOOL)doesStringContainDecimal:(NSString*) string
{
    NSString *searchForDecimal = @".";
    NSRange range = [[result stringValue] rangeOfString:searchForDecimal];
    
    if (range.location != NSNotFound)
        return YES;
    return NO;
}

- (void)calculate
{
    double currentValue = [result doubleValue];
    
    if (lastKnownValue != 0 && currentValue != 0)
    {
        if ([operand isEqualToString:@"+"])
            lastKnownValue += currentValue;
        else if ([operand isEqualToString:@"-"])
            lastKnownValue -= currentValue;
        else if ([operand isEqualToString:@"*"])
            lastKnownValue *= currentValue;
        else if ([operand isEqualToString:@"/"])
        {
            if (currentValue == 0)
                [result setStringValue: @"ERR: Devide by Zero"];
            else
                lastKnownValue /= currentValue;
        }
    }
    else
        lastKnownValue = currentValue;
}

- (void) add: (id)sender
{
    [self calculate];
    operand = @"+";
    [history setStringValue: [[history stringValue] stringByAppendingFormat:[result stringValue]]];
    [history setStringValue: [[history stringValue] stringByAppendingFormat:@" + "]];
    [result setStringValue: @""];
}


- (void) division: (id)sender
{
    [self calculate];
    operand = @"/";
    [history setStringValue: [[history stringValue] stringByAppendingFormat:[result stringValue]]];
    [history setStringValue: [[history stringValue] stringByAppendingFormat:@" / "]];
    [result setStringValue: @""];
}


- (void) eight: (id)sender
{
  if([result stringValue] == @"0.0")
       [result setStringValue: @""];
  
  [result setStringValue: [[result stringValue] stringByAppendingFormat:@"8"]];
}


- (void) equal: (id)sender
{   
  [self calculate];
  [history setStringValue: [[history stringValue] stringByAppendingFormat:[result stringValue]]];
  [history setStringValue: [[history stringValue] stringByAppendingFormat:@" = "]];
  [result setStringValue: @""];
  [result setStringValue: [NSString stringWithFormat:@"%g",lastKnownValue]];
  operand = @"";
}


- (void) erase: (id)sender
{
  [result setStringValue: @""];
  [history setStringValue: @""];
  operand = @"";
  lastKnownValue = 0;
}


- (void) five: (id)sender
{
  [result setStringValue: [[result stringValue] stringByAppendingFormat:@"5"]];
}


- (void) four: (id)sender
{
  [result setStringValue: [[result stringValue] stringByAppendingFormat:@"4"]];
}


- (void) multiply: (id)sender
{
    [self calculate];
    operand = @"*";
    [history setStringValue: [[history stringValue] stringByAppendingFormat:[result stringValue]]];
    [history setStringValue: [[history stringValue] stringByAppendingFormat:@" * "]];
    [result setStringValue: @""];
}


- (void) dot: (id)sender
{
   if ([self doesStringContainDecimal:[result stringValue]] == NO && [result stringValue] != @"")
      [result setStringValue: [[result stringValue] stringByAppendingFormat:@"."]];
}


- (void) nine: (id)sender
{
  [result setStringValue: [[result stringValue] stringByAppendingFormat:@"9"]];
}


- (void) one: (id)sender
{
  [result setStringValue: [[result stringValue] stringByAppendingFormat:@"1"]];
}


- (void) seven: (id)sender
{
  [result setStringValue: [[result stringValue] stringByAppendingFormat:@"7"]];
}


- (void) six: (id)sender
{
  [result setStringValue: [[result stringValue] stringByAppendingFormat:@"6"]];
}


- (void) subtract: (id)sender
{ 
    [self calculate];
    operand = @"-";
    [history setStringValue: [[history stringValue] stringByAppendingFormat:[result stringValue]]];
    [history setStringValue: [[history stringValue] stringByAppendingFormat:@" - "]];
    [result setStringValue: @""];
}


- (void) three: (id)sender
{
  [result setStringValue: [[result stringValue] stringByAppendingFormat:@"3"]];
}


- (void) two: (id)sender
{
  [result setStringValue: [[result stringValue] stringByAppendingFormat:@"2"]];
}


- (void) zero: (id)sender
{
  [result setStringValue: [[result stringValue] stringByAppendingFormat:@"0"]];
}

@end
