#ifndef __MCMANAGER__
#define __MCMANAGER__

#include <Foundation/NSObject.h>
#include <Foundation/NSArray.h>
#include <Foundation/NSFileManager.h>
#include <Foundation/NSDictionary.h>



/**
 * Egeszsegkozpont manager osztaly.
 */
@interface MCManager : NSObject {

	NSString* doctorResourcePath;
	NSString* diseaseResourcePath;
	NSString* patientResourcePath;


	NSMutableArray* doctors;
	NSMutableArray* diseases;
	NSMutableArray* patients;
	NSMutableDictionary* patientsToDoctorsMap;	

	NSFileManager* fm;
}


/**
 * Inicializalas.
 */
- (MCManager*) initWithParams: (NSString*) newDoctorResourcePath: (NSString*) newDiseaseResourcePath : (NSString*) newPatientResourcePath;


/**
 * Orvosok es kezelt betegsegek betoltese fajlbol.
 */
- (void) loadDoctors;

/**
 * Betegsegek es gyogyszerek betoltese fajlbol.
 */
- (void) loadDiseases;

/**
 * Betegek es betegsegek betoltese fajlbol.
 */
- (void) loadPatients;


/**
 * Betegek beosztasa orvosokhoz.
 */
- (void) organizePatients;


/**
 * Betegek ellatasa.
 */
- (void) treatPatients;



/**
 * Orvosok listazasa.
 */
- (void) listDoctors;


/**
 * Betegek listazasa.
 */
- (void) listPatients;




@end

#endif
