#include <Foundation/NSAutoreleasePool.h>
#include <Foundation/NSException.h>
#include <stdio.h>
#include "lib/entities/Human.h"
#include "lib/entities/Patient.h"
#include "lib/entities/Doctor.h"
#include "lib/entities/Disease.h"
#include "lib/utils/MCManager.h"

int main(int argc, char* argv[]) {

	// autorelease pool letrehozasa
	NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

	MCManager* manager = [[MCManager alloc] init];

	@try {

		// manager objektum letrehozasa
		[manager initWithParams: @"res/doctors.csv" : @"res/diseases.csv" : @"res/patients.csv"];

		// adatok betoltese
		[manager loadDoctors];
		[manager loadDiseases];
		[manager loadPatients];

		// adatok megjelenitese
		[manager listDoctors];
		[manager listPatients];

		// betegek beosztasa orvosokhoz 
		[manager organizePatients];
		[manager treatPatients];
		


	}@catch(NSException* e) {
		printf("%s\n", [[e reason] cString]);
	}@finally {
		[pool release];
	}


	// memoriaterulet felszabaditasa
	[pool release];

	return 0;
}
