#import "state.h" 
#import "szamla.h" 
#import "ezustUgyfel.h" 
#import "aranyUgyfel.h" 
#import "negativUgyfel.h" 

@implementation EzustUgyfel 

- (EzustUgyfel*) inicParameterrel : (State*) state
{ 	
    return [ self inic : state.egyenleg sz: state.szamla ];
} 

- (EzustUgyfel*) inic : (double) egyenlege sz: (Szamla*) szamlaa
{ 
	egyenleg = egyenlege;
	szamla = szamlaa;        
	[ self initialize ];
	return self;
}
- (void) initialize
{ 	
	_kamat = 0.01;
	_alsoLimit = 0.0;
	_felsoLimit = 1000.0;
} 

- (void) befizet: (double) osszeg
{ 
	egyenleg += osszeg;
	[ self AllapotValtozasEllenorzese ];
} 
- (void) kivesz: (double) osszeg
{ 
	egyenleg -= osszeg;
	[ self AllapotValtozasEllenorzese ];
} 
- (void) kamatotJovair
{ 
	egyenleg += _kamat * egyenleg;
	[ self AllapotValtozasEllenorzese ];
} 
- (void) AllapotValtozasEllenorzese
{ 
	if (egyenleg < _alsoLimit)
	{
		szamla.allapot = [[ NegativUgyfel alloc ] inicParameterrel : self];
	}
	else if (egyenleg > _felsoLimit)
	{
		szamla.allapot = [[ AranyUgyfel alloc ] inicParameterrel : self];
	}
} 
- (void) allapotKiir
{
	NSLog (@"Allapot = ezustUgyfel");  
}
@end ;