#import "World.h"
#include <stdio.h>

static int tellatale;

@implementation World
	+ (int) getMaxPlace
	{
		return 4;
	}
	+ (NSString *) getPlace: (int) pnum
	{
		switch (pnum)
		{
			case 0: return @"dombok"; 
			case 1: return @"volgyek";
			case 2: return @"erdok";
			case 3: return @"mezok";
			default: return @"ismeretlen";
		}
	}
	+ (NSString *) getPlaceAt: (int) pnum
	{
		switch (pnum)
		{
			case 0: return @"dombokat"; 
			case 1: return @"volgyeket";
			case 2: return @"erdoket";
			case 3: return @"mezoket";
			default: return @"ismeretlent";
		}		
	}
	+ (NSString *) getPlaceTo: (int) pnum
	{
		switch (pnum)
		{
			case 0: return @"dombokhoz"; 
			case 1: return @"volgyekhez";
			case 2: return @"erdokhoz";
			case 3: return @"mezokhoz";
			default: return @"ismeretlenbe";
		}	
	}
	
	+ (void) endOfTale
	{
		tellatale = 0;
	}
	
	+ (void) printStatement: (NSString *) statement
	{
		printf("%s\n", [statement UTF8String]);
	}
	
	+ (void) printTale: (id<ITaleFactory>) factory
	{
		tellatale = 1;
		id<IChar> player1 = [factory createFirst];
		id<IChar> player2 = [factory createSecond];
		NSString* title = [factory createTitle];
		[World printStatement: title];
		[player1 setOpponent: player2];
		[player2 setOpponent: player1];
		while (tellatale)
		{
			[player1 turn];
			if (tellatale) [player2 turn];
		}
	}
@end
