#import <Foundation/Foundation.h> 
#import <AppKit/AppKit.h> 
#import "AppControl.h"

@implementation AppControl

// segitsegevel a delegalt tovabbi inicializacios muveleteket hajthat vegre.
// ebben az esetben itt tortenik a menu es az alkamazas alakanak letrehozasa,
// valamint a Tilitoli objektumunk létrehozása és init muveletehez tartozo
// parameterek ellenorzese.
- (void)applicationDidFinishLaunching:(NSNotification *)notif 
{ 
    NSProcessInfo *procInfo = [NSProcessInfo processInfo]; 
    NSArray *args = [procInfo arguments]; 
 
    NSString *kepUtvonal; 
    NSImage *kep; 
    int meret; 
    Tilitoli *tt; 
 
    NSMenu *menu = [NSMenu new]; 
 
    NSWindow *ttAblak; 
    NSRect ablakRect;

	srand48(time(NULL));  
 
	[menu addItemWithTitle: @"Keveres" 
          action:@selector(kever:) 
          keyEquivalent:@""]; 
    [menu addItemWithTitle: @"Kilepes" 
          action:@selector(terminate:) 
          keyEquivalent:@"q"]; 
    [NSApp setMainMenu:menu]; 
 
    [menu display];

	if([args count]!=3){ 
        [NSException raise:NSInvalidArgumentException 
                      format:@"Meg kell adni az argumentumokat: <meret> <kep>"]; 
    } 
 
    meret = [[args objectAtIndex:1] intValue]; 
    if(meret<MINDIM || meret>MAXDIM){ 
        [NSException raise:NSRangeException 
                      format:@"A meret nem csak a (%d - %d) intervallumbol lehet: %d", 
                      MINDIM, MAXDIM, meret]; 
    }

	kepUtvonal = [args objectAtIndex:2]; 
    kep = [[NSImage alloc] initWithContentsOfFile:kepUtvonal]; 
    if(kep==nil){ 
        [NSException raise:NSInvalidArgumentException 
                      format:@"Nincs kep ezen az utvonalon: %@", kepUtvonal]; 
    }
	
	tt = [[Tilitoli alloc] 
             initPont:NSMakePoint(0, 0) 
             andKep:kep andDimenzio:meret]; 
 
    ablakRect.origin = NSMakePoint(0, 0); 
    ablakRect.size = [tt bounds].size;

	ttAblak = [[NSWindow alloc] 
                initWithContentRect:ablakRect 
                styleMask:NSTitledWindowMask 
                backing:NSBackingStoreBuffered 
                defer:NO]; 
    [ttAblak setTitle:@"Tilitoli"]; 
 
    [ttAblak setContentView:tt]; 
    [ttAblak setInitialFirstResponder:tt]; 
 
    [ttAblak center]; 
    [ttAblak makeKeyAndOrderFront:nil]; 
} 
 
@end

// a program belepesi pontja
int main(int argc, char** argv, char **env) 
{ 
    NSAutoreleasePool *pool = [NSAutoreleasePool new]; 
    NSApplication *app; 
 
    app = [NSApplication sharedApplication]; 
    [app setDelegate:[AppControl new]]; 
    [app run]; 
 
    [pool release]; 
    exit(0); 
}
