#import "ETR.h"

@implementation ETR
  - (id) init
    {
      courses  = [[NSMutableArray alloc] init];
      teachers = [[NSMutableArray alloc] init];
      students = [[NSMutableArray alloc] init];
      return self;
    }

  - (Course*) findCourse: (NSString*)course_code
    {
      NSEnumerator *enumerator = [courses objectEnumerator];
      Course *course;

      while (course = [enumerator nextObject])
      {
        if ([course.code isEqualToString:course_code])
        {
           return course;
        }
      }
      return nil;
    }

  - (EtrHuman*) findPerson: (NSString*)eha inList:(NSMutableArray*)list
    {
      NSEnumerator *enumerator = [list objectEnumerator];
      EtrHuman *person;

      while (person = [enumerator nextObject])
      {
        if ([person.eha isEqualToString:eha])
        {
           return person;
        }
      }
      return nil;
    }

  //Add course and teacher. (There is a one-one relationship between them.)
  - (void) addCourse: (Course*)c Teacher: (Teacher*)t
    {
      Course *course = [self findCourse:c.code];
      if (course != nil)
      {
        fprintf(stderr, "Course already exists.\n");
        return;
      }
      Teacher *teacher = (Teacher*)[self findPerson:t.eha inList:teachers];
      if (teacher != nil)
      {
        fprintf(stderr, "Teacher already exists.\n");
        return;
      }
      [courses addObject:c];
      [teachers addObject:t];
    }

  - (void) addStudent: (Student*)s
    {
      Student *student = (Student*)[self findPerson:s.eha inList:students];
      if (student != nil)
      {
        fprintf(stderr, "Student already exists.\n");
        return;
      }
      [students addObject:s];
    }

  - (void) applyCourse: (NSString*)student_eha course: (NSString*)course_code
    {
      Student *student = (Student*)[self findPerson:student_eha inList:students];

      if (student == nil)
      {
        fprintf(stderr, "Student not found.\n");
        return;
      }
      
      Course *course = [self findCourse:course_code];

      if (course == nil)
      {
        fprintf(stderr, "Course not found.\n");
        return;
      }

      [student addCourse:course];
      [course addStudent:student];
    }

  - (void) printTimeTable
    {
      NSEnumerator *enumerator = [students objectEnumerator];
      Student *student;

      while (student = [enumerator nextObject])
      {
         printf("%s (%s) studies\n"
                "--------------------\n",
                [student.name UTF8String],
                [student.eha UTF8String]);
         [student printCourseList];
      }
    }

@end

