//
// Shapes pldaprogram, objectumok ltrehozsa, lncolsra
// @interface, @implementation, @protocol, id
//
// A pldaprogramban alakzatokat hozunkltre, amelyeket egy listba fznk fel, 
// majd ezt a listt printeljk ki
//
// fordts:
// gcc -o shapes shapes.m -I c:/GNUstep/GNUstep/System/Library/Headers -L c:/GNUstep/GNUstep/System/Library/Libraries -std=c99 -lobjc -lgnustep-base -fconstant-string-class=NSConstantString
//
// Ksztette: Igncz Imre
//             2012.05.05.

//#include <Foundation/Foundation.h>
#import <Foundation/NSObject.h>
#import <stdio.h>

////////////////////// egy protokoll, ami egy print selectort tartalmaz ////////////////////////

@protocol printable
@required
- (void) print;
@end

////////////////////// alakzat osztly definicija/implementcija ////////////////////////

@interface Shape: NSObject <printable>
@end

@implementation Shape 
-(void) print 
{
    printf( "Shape\n");
}
@end

////////////////////// alakzatok definicija s implementcija ////////////////////////

@interface Teglalap: Shape
@end

@interface Negyzet: Teglalap
@end

@interface Kor: Shape 
@end


@implementation Teglalap
-(void) print 
{
    printf( "Teglalap\n");
}
@end

@implementation Negyzet
-(void) print 
{
    printf( "Negyzet\n");
}
@end

@implementation Kor
-(void) print 
{
    printf( "Kor\n");
}
@end

////////////////////// a node-ok definicija s implementcija ////////////////////////

@interface Node: NSObject {
	id obj;
	id next;
}
- (id) init: (id) object withNext: (id) nextnode; 
- (id) obj;
- (id) next;
@end

@implementation Node 
- (id) init: (id) object withNext: (id) nextnode
{
	self=[super init];

	//elmentjk az objektumot, majd a nextet a meglv elemekre lltjuk
	//majd mi lesznk a fejelem visszatrs utn
	obj=object;
	next=nextnode;

	return self;
}

- (id) obj
{
	return obj;
}

- (id) next 
{
	return next;
}

- (void) dealloc
{
	//ha van objektum a node-on akkor trljk azt
	if (obj!=nil)
	{
		[obj release];
	}

	//ha van next elem, akkor elbb azt is felszabadtjuk
	if (next!=nil)
	{
		[next release];
	}

	[super dealloc];
}
@end

////////////////////// a node-ok listjnak definicija s implementcija ////////////////////////

@interface List: NSObject <printable> {
	id head;
}
- (id) init;
- (void) add: (id) shape;
@end

@implementation List
- (id) init
{
	self=[super init];

	//listnk alapban res
	head=nil;  

	return self;
}

- (void) add: (id) object
{
	//ltrehozunk egy j nodeot, ami a lnc elejre fog kerlni
	// a meglv elemeke a node nextje fog majd mutatni
	head=[[Node alloc] init: object withNext: head];
}

- (void) print 
{
	//vgig megynk a listn, amg az aktulis node rtke nill nem nem lesz
	//az utols elem mindig nil lesz
	for (id node=head;node!=nil;)
	{
		//meghvjuk az adott node objektumra a kiirst
		[[node obj] print];

		//majd elkrjk a kvetkez elemet a lncban
		node=[node next];
	}
}

- (void) dealloc
{
	//ha a fejelem nem res, akkor trljk
	if (head!=nil)
	{
		[head release];
	}

	//meghjuk az s deallocjt, ha mr felldefiniltuk azt
	[super dealloc];
}
@end

////////////////////// MAIN PROGRAM ////////////////////////

int main(void)
{
	//lista ltrehozsa
	List *list=[[List alloc] init];

	//alakzatok ltrehozsa
	Teglalap *teglalap = [[Teglalap alloc] init];
	Negyzet *negyzet = [[Negyzet alloc] init];
	Kor *kor = [[Kor alloc] init];
	Shape *shape=kor;

	//hozzadjuk az elemeket a listhoz
	[list add:negyzet];
	[list add:teglalap];
	[list add:kor];

	//vagy akr direkt mdon is lehet hozzadni
	[list add:[[Negyzet alloc] init]];

	//dinamikus teszt, itt kort adunk hozz valjban
	[shape retain]; //mert ez ugyanaz a kor amit mr hozzadtunk egyszer, hogy lehessen 2x hivni a dealloc-ot
	[list add: shape];

	//kiirjuk a listt
	[list print];

	//majd trljuk a listt (ami majd trli az objektumokat is amiket tartalmaz)    
	[list release];

	return 0;
}
