﻿#import <Foundation/Foundation.h>

/*
gcc -o tasks tasks.m -I /GNUstep/System/Library/Headers \
-L /GNUstep/System/Library/Libraries -lobjc \
-lgnustep-base -fconstant-string-class=NSConstantString
*/

int main (int argc, const char * argv[])
{
	//autoreleasepool szükséges ahhoz, hogy az automatikusan
	//felszabadulo objektumok ténylegesen fel is szabaduljanak
        NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

        //Létrehoz egy új taszk objektumot
        NSTask *task = [[NSTask alloc] init];
        //Beállítja a futtatandó programot
        [task setLaunchPath: @"./hello"];
        
	//pipe a kimenet tárolásához        
        NSPipe *pipe = [ [ NSPipe alloc ] init ];
        [task setStandardError:pipe];
        [task setStandardOutput:pipe];
        
        //pipe-ból egy file handle segítségével kiolvashatóak lesznek az adatok
        NSFileHandle *file;
        file = [pipe fileHandleForReading];

        //futtatás
        [task launch];
        
        //megvárja, amíg befejezõdik a taszk
        [task waitUntilExit];
        NSLog (@"Task finished!");
    
        //kiolvassa a fájlból az adatokat
        NSData *data;
        data = [file readDataToEndOfFile];
        
        //létrehoz egy sztringet a kiolvasott adatokbol
        NSString *string;
        string = [[NSString alloc] initWithData: data encoding: NSUTF8StringEncoding];
        
        //kiirja az eredmenyt
        NSLog (@"Result:\n%@", string);
        
        //felszabaditja az automatikusan létrehozott objektumokat
        [pool drain];
        return 0;
}

