﻿#import <Foundation/Foundation.h>
#import <unistd.h>

/*
gcc -o thread thread.m -I /GNUstep/System/Library/Headers \
-L /GNUstep/System/Library/Libraries -lobjc \
-lgnustep-base -fconstant-string-class=NSConstantString
*/

@interface NumberPrinter : NSObject
//+ : statikus(osztalyszintu) metodus - nem kell objektumot letrehozni
//a hasznalathoz
+(void) printNumbers: (id) param;
@end

//zar
NSLock *lock;

@implementation NumberPrinter
+(void) printNumbers: (id) param{
    int j;    
    for(j=0;j<40;++j)
    {
    	//zarolas (a _lock_ nevu objektumnak kuldott uzenet: "lock")
    	[lock lock];
        printf("j == %i\n",j);
        //zar elengedese (a kuldott uzenet: "unlock")
        [lock unlock];
        usleep(2000);
    }
}

@end

int main(int argc, char *argv[])
{
    int i;
    lock = [[NSLock alloc] init];

    //uj szal letrehozasa, ami futtatja a NumberPrinter osztaly printNumbers metodusat
    [NSThread detachNewThreadSelector:@selector(printNumbers:) toTarget:[NumberPrinter class] withObject:nil];

    for(i=0;i<40;++i)
    {
    	//blokkol, ha mar lock-olva van, megvarja a felszabaditast a 
    	//printNumbers metodusban
    	[lock lock];
    	//a ket print egymas alatt kell, hogy megjelenjen,
    	//nem szakithatja meg oket "j" cimkeju sor a lock miatt
        printf("i == %i\n",i);
        printf("i ^^\n");
        //felszabaditja a lock-ot, aki varakozik, az folytathatja tovabb a
        //lockolast es feldolgozast(printNumbers)
        [lock unlock];
        usleep(2000);
    }

    return 0;
}

