﻿#import <Foundation/Foundation.h>
#import <unistd.h>

/*
gcc -o timer timer.m -I /GNUstep/System/Library/Headers \
-L /GNUstep/System/Library/Libraries -lobjc \
-lgnustep-base -fconstant-string-class=NSConstantString
*/

@interface NumberPrinter : NSObject
-(void) printNumbers: (NSNumber *) start;
-(void) delayPrintNumbers: (NSNumber *) start;
@end

//zar
NSLock *lock;

@implementation NumberPrinter
-(void) printNumbers: (NSNumber *) start {
    int j;
    //ertek lekerdezese a csomagolo osztalytol
    int first = [start intValue];    
    for(j=first;j<first+40;++j)
    {
        printf("j == %i\n",j);
    }
}
-(void) delayPrintNumbers: (NSNumber *) start {
   //performSelector - lefuttatja a parameterkent kapott szelectort(uzenetet)
   //adhatunk a szelektornak parametert (withObject)
   //es kesleltetes (afterDelay)
   [self performSelector:@selector(printNumbers:) withObject:start afterDelay:1.0];
   //timer csak akkor mûködik, ha fut az esemenykezelo ciklus - run futtatja
   [[NSRunLoop currentRunLoop] run];

}
@end

int main(int argc, char *argv[])
{
    //AutoreleasePool vegzi az automatikus felszabaditast
    //itt az NSNumber numberWithInt uzenete miatt szukseges,
    //ami automatikusan felszabadulo NSNumber objektumot ad vissza
    //igy nem kell a program vegen release-elni.
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

    int i;
    lock = [[NSLock alloc] init];

    NumberPrinter * np = [[NumberPrinter alloc] init];
    //becsomagol egy int-et
    NSNumber * start = [NSNumber numberWithInt: 200];
    //uj szal letrehozasa, ami futtatja az np objektum printNumbers metodusat, start parameterrel
    [NSThread detachNewThreadSelector:@selector(delayPrintNumbers:) toTarget:np withObject:start];

    //a 20-as lepes elott fog lefutni a masik szal, a kesletetes miatt
    for(i=0;i<40;++i)
    {
        printf("i == %i\n",i);
        usleep(50000);
    }

    //automatikus felszabaditas elvegzese
    [pool drain];
    return 0;
}

